_initShadowMemoriesTraces:
;Flash.c,29 :: 		void initShadowMemoriesTraces(){
;Flash.c,31 :: 		for (i=0; i< 131; i++){
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_initShadowMemoriesTraces0:
; i start address is: 16 (R4)
ANDI	R2, R4, 255
SLTIU	R2, R2, 131
BNE	R2, R0, L__initShadowMemoriesTraces18
NOP	
J	L_initShadowMemoriesTraces1
NOP	
L__initShadowMemoriesTraces18:
;Flash.c,33 :: 		m_ProgramFlashBlocksTrace[i] = 0; // mark block as not deleted
ANDI	R3, R4, 255
LUI	R2, hi_addr(_m_ProgramFlashBlocksTrace+0)
ORI	R2, R2, lo_addr(_m_ProgramFlashBlocksTrace+0)
ADDU	R2, R2, R3
SB	R0, 0(R2)
;Flash.c,31 :: 		for (i=0; i< 131; i++){
ADDIU	R2, R4, 1
ANDI	R4, R2, 255
;Flash.c,34 :: 		}
; i end address is: 16 (R4)
J	L_initShadowMemoriesTraces0
NOP	
L_initShadowMemoriesTraces1:
;Flash.c,35 :: 		}
L_end_initShadowMemoriesTraces:
JR	RA
NOP	
; end of _initShadowMemoriesTraces
_eraseFlashFromUserApplicationStart:
;Flash.c,37 :: 		void eraseFlashFromUserApplicationStart(){
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;Flash.c,38 :: 		unsigned long  pageStartAddr = USER_APP_RESRT_ADDR; // this is virtual address
SW	R25, 4(SP)
; pageStartAddr start address is: 24 (R6)
LUI	R6, 40192
ORI	R6, R6, 40960
;Flash.c,39 :: 		unsigned short pageIndex = getPageIndex(KVA_TO_PA(USER_APP_RESRT_ADDR));
LUI	R25, 7424
ORI	R25, R25, 40960
JAL	_getPageIndex+0
NOP	
; pageIndex start address is: 20 (R5)
; pageIndex start address is: 20 (R5)
ANDI	R5, R2, 255
; pageStartAddr end address is: 24 (R6)
; pageIndex end address is: 20 (R5)
;Flash.c,40 :: 		do {
J	L_eraseFlashFromUserApplicationStart3
NOP	
L__eraseFlashFromUserApplicationStart16:
;Flash.c,45 :: 		}while (pageStartAddr < 0x9D07FFFF);
MOVZ	R6, R4, R0
;Flash.c,40 :: 		do {
L_eraseFlashFromUserApplicationStart3:
;Flash.c,41 :: 		Flash_Erase_Page(pageStartAddr);
; pageIndex start address is: 20 (R5)
; pageStartAddr start address is: 16 (R4)
; pageStartAddr start address is: 24 (R6)
MOVZ	R25, R6, R0
JAL	_Flash_Erase_Page+0
NOP	
;Flash.c,42 :: 		m_ProgramFlashBlocksTrace[pageIndex] = 1; //mark as erased
ANDI	R3, R5, 255
LUI	R2, hi_addr(_m_ProgramFlashBlocksTrace+0)
ORI	R2, R2, lo_addr(_m_ProgramFlashBlocksTrace+0)
ADDU	R3, R2, R3
ORI	R2, R0, 1
SB	R2, 0(R3)
;Flash.c,43 :: 		pageStartAddr += 0x1000;
ADDIU	R3, R6, 4096
; pageStartAddr end address is: 24 (R6)
; pageStartAddr start address is: 16 (R4)
MOVZ	R4, R3, R0
; pageStartAddr end address is: 16 (R4)
;Flash.c,44 :: 		pageIndex++;
ADDIU	R2, R5, 1
ANDI	R5, R2, 255
; pageIndex end address is: 20 (R5)
;Flash.c,45 :: 		}while (pageStartAddr < 0x9D07FFFF);
LUI	R2, 40199
ORI	R2, R2, 65535
SLTU	R2, R3, R2
BEQ	R2, R0, L__eraseFlashFromUserApplicationStart20
NOP	
J	L__eraseFlashFromUserApplicationStart16
NOP	
L__eraseFlashFromUserApplicationStart20:
; pageStartAddr end address is: 16 (R4)
; pageIndex end address is: 20 (R5)
;Flash.c,46 :: 		}
L_end_eraseFlashFromUserApplicationStart:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _eraseFlashFromUserApplicationStart
_initShadowMemory:
;Flash.c,49 :: 		void initShadowMemory(){
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;Flash.c,50 :: 		initShadowMemoriesTraces();
JAL	_initShadowMemoriesTraces+0
NOP	
;Flash.c,51 :: 		m_oneShot = FALSE;
SB	R0, Offset(_m_oneShot+0)(GP)
;Flash.c,52 :: 		eraseFlashFromUserApplicationStart();
JAL	_eraseFlashFromUserApplicationStart+0
NOP	
;Flash.c,53 :: 		}
L_end_initShadowMemory:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _initShadowMemory
_writeDataToShadowOfFlashBlock:
;Flash.c,67 :: 		void writeDataToShadowOfFlashBlock(hexLine_t *ptrHexObj){
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;Flash.c,68 :: 		unsigned long numBytesPageOverflow = 0;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
;Flash.c,73 :: 		dataBlockIndex = getPageIndex(ptrHexObj->realAddess);
ADDIU	R2, R25, 12
SW	R25, 16(SP)
LW	R25, 0(R2)
JAL	_getPageIndex+0
NOP	
LW	R25, 16(SP)
; dataBlockIndex start address is: 28 (R7)
ANDI	R7, R2, 255
;Flash.c,75 :: 		if (m_oneShot == FALSE){
LBU	R2, Offset(_m_oneShot+0)(GP)
BEQ	R2, R0, L__writeDataToShadowOfFlashBlock23
NOP	
J	L_writeDataToShadowOfFlashBlock6
NOP	
L__writeDataToShadowOfFlashBlock23:
;Flash.c,76 :: 		m_shadowPage.phyPageStartAddr =  GetPhyStartPageAddress(ptrHexObj->realAddess);
ADDIU	R2, R25, 12
SW	R25, 16(SP)
LW	R25, 0(R2)
JAL	_GetPhyStartPageAddress+0
NOP	
SW	R2, Offset(_m_shadowPage+4)(GP)
;Flash.c,77 :: 		ulPtr = physicaToKseg1(m_shadowPage.phyPageStartAddr);
MOVZ	R25, R2, R0
JAL	_physicaToKseg1+0
NOP	
;Flash.c,78 :: 		memcpy(m_shadowPage.shadowBlock,ulPtr, FLASH_ERASE_BLOCK_SIZE);  // read from flash
ORI	R27, R0, 4096
MOVZ	R26, R2, R0
LUI	R25, hi_addr(_m_shadowPage+8)
ORI	R25, R25, lo_addr(_m_shadowPage+8)
JAL	_memcpy+0
NOP	
LW	R25, 16(SP)
;Flash.c,79 :: 		m_shadowPage.blockIndex = dataBlockIndex;
SB	R7, Offset(_m_shadowPage+0)(GP)
;Flash.c,80 :: 		m_oneShot = TRUE;
ORI	R2, R0, 1
SB	R2, Offset(_m_oneShot+0)(GP)
;Flash.c,81 :: 		}
L_writeDataToShadowOfFlashBlock6:
;Flash.c,83 :: 		if(m_shadowPage.blockIndex != dataBlockIndex){ // new arriving data is in another flash page than the shadow
ANDI	R3, R7, 255
LBU	R2, Offset(_m_shadowPage+0)(GP)
BNE	R2, R3, L__writeDataToShadowOfFlashBlock25
NOP	
J	L_writeDataToShadowOfFlashBlock7
NOP	
L__writeDataToShadowOfFlashBlock25:
;Flash.c,91 :: 		writeShadowToFlash();
JAL	_writeShadowToFlash+0
NOP	
;Flash.c,94 :: 		m_shadowPage.phyPageStartAddr =  GetPhyStartPageAddress(ptrHexObj->realAddess);
ADDIU	R2, R25, 12
SW	R25, 16(SP)
LW	R25, 0(R2)
JAL	_GetPhyStartPageAddress+0
NOP	
SW	R2, Offset(_m_shadowPage+4)(GP)
;Flash.c,95 :: 		ulPtr =  physicaToKseg1(m_shadowPage.phyPageStartAddr);
MOVZ	R25, R2, R0
JAL	_physicaToKseg1+0
NOP	
;Flash.c,96 :: 		memcpy(m_shadowPage.shadowBlock, ulPtr, FLASH_ERASE_BLOCK_SIZE);
ORI	R27, R0, 4096
MOVZ	R26, R2, R0
LUI	R25, hi_addr(_m_shadowPage+8)
ORI	R25, R25, lo_addr(_m_shadowPage+8)
JAL	_memcpy+0
NOP	
LW	R25, 16(SP)
;Flash.c,97 :: 		m_shadowPage.blockIndex = dataBlockIndex;
SB	R7, Offset(_m_shadowPage+0)(GP)
; dataBlockIndex end address is: 28 (R7)
;Flash.c,98 :: 		}
L_writeDataToShadowOfFlashBlock7:
;Flash.c,101 :: 		offsetInPage = ptrHexObj->realAddess - m_shadowPage.phyPageStartAddr;
ADDIU	R2, R25, 12
LW	R3, 0(R2)
LW	R2, Offset(_m_shadowPage+4)(GP)
SUBU	R3, R3, R2
; offsetInPage start address is: 24 (R6)
MOVZ	R6, R3, R0
;Flash.c,102 :: 		if ( (offsetInPage + ptrHexObj->dataLength) > FLASH_ERASE_BLOCK_SIZE){    //if the current hex row data spans two adjacent pages
LBU	R2, 0(R25)
ANDI	R2, R2, 255
ADDU	R2, R3, R2
SLTIU	R2, R2, 4097
BEQ	R2, R0, L__writeDataToShadowOfFlashBlock26
NOP	
J	L_writeDataToShadowOfFlashBlock8
NOP	
L__writeDataToShadowOfFlashBlock26:
;Flash.c,103 :: 		numBytesPageOverflow =  offsetInPage + ptrHexObj->dataLength - FLASH_ERASE_BLOCK_SIZE;
LBU	R4, 0(R25)
ANDI	R2, R4, 255
ADDU	R2, R6, R2
ADDIU	R3, R2, -4096
; numBytesPageOverflow start address is: 28 (R7)
MOVZ	R7, R3, R0
;Flash.c,105 :: 		memcpy(& m_shadowPage.shadowBlock[offsetInPage], ptrHexObj->hexBinData,ptrHexObj->dataLength - numBytesPageOverflow);
ANDI	R2, R4, 255
SUBU	R4, R2, R3
ADDIU	R3, R25, 16
LUI	R2, hi_addr(_m_shadowPage+8)
ORI	R2, R2, lo_addr(_m_shadowPage+8)
ADDU	R2, R2, R6
; offsetInPage end address is: 24 (R6)
SW	R25, 16(SP)
SEH	R27, R4
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
LW	R25, 16(SP)
;Flash.c,112 :: 		writeShadowToFlash();
JAL	_writeShadowToFlash+0
NOP	
;Flash.c,115 :: 		m_shadowPage.phyPageStartAddr += 0x1000; // adjacent page starts at 4K bytes from the current
LW	R2, Offset(_m_shadowPage+4)(GP)
ADDIU	R2, R2, 4096
SW	R2, Offset(_m_shadowPage+4)(GP)
;Flash.c,116 :: 		ulPtr =   physicaToKseg1(m_shadowPage.phyPageStartAddr);
SW	R25, 16(SP)
MOVZ	R25, R2, R0
JAL	_physicaToKseg1+0
NOP	
;Flash.c,117 :: 		memcpy(m_shadowPage.shadowBlock, ulPtr, FLASH_ERASE_BLOCK_SIZE); // fill shadow from flash ****
ORI	R27, R0, 4096
MOVZ	R26, R2, R0
LUI	R25, hi_addr(_m_shadowPage+8)
ORI	R25, R25, lo_addr(_m_shadowPage+8)
JAL	_memcpy+0
NOP	
LW	R25, 16(SP)
;Flash.c,118 :: 		m_shadowPage.blockIndex ++; // the block index is adjacent to the last one
LBU	R2, Offset(_m_shadowPage+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(_m_shadowPage+0)(GP)
;Flash.c,121 :: 		ulPtr = ptrHexObj->hexBinData + (ptrHexObj->dataLength - numBytesPageOverflow);
ADDIU	R3, R25, 16
LBU	R2, 0(R25)
ANDI	R2, R2, 255
SUBU	R2, R2, R7
ADDU	R2, R3, R2
;Flash.c,122 :: 		memcpy(m_shadowPage.shadowBlock, ulPtr, numBytesPageOverflow); //****
MOVZ	R27, R7, R0
; numBytesPageOverflow end address is: 28 (R7)
MOVZ	R26, R2, R0
LUI	R25, hi_addr(_m_shadowPage+8)
ORI	R25, R25, lo_addr(_m_shadowPage+8)
JAL	_memcpy+0
NOP	
;Flash.c,123 :: 		} else{
J	L_writeDataToShadowOfFlashBlock9
NOP	
L_writeDataToShadowOfFlashBlock8:
;Flash.c,125 :: 		memcpy(& m_shadowPage.shadowBlock[offsetInPage], ptrHexObj->hexBinData, ptrHexObj->dataLength);
; offsetInPage start address is: 24 (R6)
LBU	R4, 0(R25)
ADDIU	R3, R25, 16
LUI	R2, hi_addr(_m_shadowPage+8)
ORI	R2, R2, lo_addr(_m_shadowPage+8)
ADDU	R2, R2, R6
; offsetInPage end address is: 24 (R6)
ANDI	R27, R4, 255
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_memcpy+0
NOP	
;Flash.c,126 :: 		}
L_writeDataToShadowOfFlashBlock9:
;Flash.c,127 :: 		}
L_end_writeDataToShadowOfFlashBlock:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _writeDataToShadowOfFlashBlock
_writeShadowToFlash:
;Flash.c,129 :: 		void writeShadowToFlash(void) {
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;Flash.c,133 :: 		virtualAddrOfPageStart =  physicaToKseg1(m_shadowPage.phyPageStartAddr);
SW	R25, 4(SP)
SW	R26, 8(SP)
LW	R25, Offset(_m_shadowPage+4)(GP)
JAL	_physicaToKseg1+0
NOP	
; virtualAddrOfPageStart start address is: 20 (R5)
MOVZ	R5, R2, R0
;Flash.c,135 :: 		if (m_ProgramFlashBlocksTrace[m_shadowPage.blockIndex] == 0){ // page has not been erased
LBU	R3, Offset(_m_shadowPage+0)(GP)
LUI	R2, hi_addr(_m_ProgramFlashBlocksTrace+0)
ORI	R2, R2, lo_addr(_m_ProgramFlashBlocksTrace+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BEQ	R2, R0, L__writeShadowToFlash28
NOP	
J	L_writeShadowToFlash10
NOP	
L__writeShadowToFlash28:
;Flash.c,136 :: 		Flash_Erase_Page(virtualAddrOfPageStart); // erase before write
MOVZ	R25, R5, R0
JAL	_Flash_Erase_Page+0
NOP	
;Flash.c,137 :: 		m_ProgramFlashBlocksTrace[m_shadowPage.blockIndex] = 1; // mark it as 'has been erased'
LBU	R3, Offset(_m_shadowPage+0)(GP)
LUI	R2, hi_addr(_m_ProgramFlashBlocksTrace+0)
ORI	R2, R2, lo_addr(_m_ProgramFlashBlocksTrace+0)
ADDU	R3, R2, R3
ORI	R2, R0, 1
SB	R2, 0(R3)
;Flash.c,138 :: 		}
L_writeShadowToFlash10:
;Flash.c,140 :: 		for (i=0; i<8; i++){
; i start address is: 24 (R6)
MOVZ	R6, R0, R0
; i end address is: 24 (R6)
L_writeShadowToFlash11:
; i start address is: 24 (R6)
; virtualAddrOfPageStart start address is: 20 (R5)
; virtualAddrOfPageStart end address is: 20 (R5)
SLTIU	R2, R6, 8
BNE	R2, R0, L__writeShadowToFlash29
NOP	
J	L_writeShadowToFlash12
NOP	
L__writeShadowToFlash29:
; virtualAddrOfPageStart end address is: 20 (R5)
;Flash.c,141 :: 		Flash_Write_Row(virtualAddrOfPageStart + i*512, & m_shadowPage.shadowBlock[512 *i]);
; virtualAddrOfPageStart start address is: 20 (R5)
SLL	R4, R6, 9
LUI	R2, hi_addr(_m_shadowPage+8)
ORI	R2, R2, lo_addr(_m_shadowPage+8)
ADDU	R3, R2, R4
ADDU	R2, R5, R4
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_Flash_Write_Row+0
NOP	
;Flash.c,140 :: 		for (i=0; i<8; i++){
ADDIU	R2, R6, 1
MOVZ	R6, R2, R0
;Flash.c,142 :: 		}
; virtualAddrOfPageStart end address is: 20 (R5)
; i end address is: 24 (R6)
J	L_writeShadowToFlash11
NOP	
L_writeShadowToFlash12:
;Flash.c,143 :: 		}
L_end_writeShadowToFlash:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _writeShadowToFlash
_GetPhyStartPageAddress:
;Flash.c,145 :: 		unsigned long GetPhyStartPageAddress(unsigned long phyAddress){
;Flash.c,147 :: 		return   phyAddress & ~(FLASH_ERASE_BLOCK_SIZE -1);
LUI	R2, 65535
ORI	R2, R2, 61440
AND	R2, R25, R2
;Flash.c,148 :: 		}
L_end_GetPhyStartPageAddress:
JR	RA
NOP	
; end of _GetPhyStartPageAddress
_getPageIndex:
;Flash.c,150 :: 		unsigned short getPageIndex(unsigned long phyAddress){
;Flash.c,151 :: 		if (phyAddress < PHY_START_BOOT_FLASH){
LUI	R2, 8128
SLTU	R2, R25, R2
BNE	R2, R0, L__getPageIndex32
NOP	
J	L_getPageIndex14
NOP	
L__getPageIndex32:
;Flash.c,152 :: 		return  (unsigned short) ((phyAddress - PHY_START_PROGRAM_FLASH)>>12);
LUI	R2, 7424
SUBU	R2, R25, R2
SRL	R2, R2, 12
J	L_end_getPageIndex
NOP	
;Flash.c,153 :: 		} else {
L_getPageIndex14:
;Flash.c,154 :: 		return  (unsigned short)(((phyAddress - PHY_START_BOOT_FLASH) >>12)) +128; //boot flash indexes ara 128,129,130
LUI	R2, 8128
SUBU	R2, R25, R2
SRL	R2, R2, 12
ADDIU	R2, R2, 128
;Flash.c,156 :: 		}
L_end_getPageIndex:
JR	RA
NOP	
; end of _getPageIndex
_physicaToKseg1:
;Flash.c,158 :: 		unsigned long physicaToKseg1(unsigned long physicalAddr){
;Flash.c,160 :: 		return  physicalAddr | 0x80000000;
LUI	R2, 32768
OR	R2, R25, R2
;Flash.c,161 :: 		}
L_end_physicaToKseg1:
JR	RA
NOP	
; end of _physicaToKseg1
