#ifndef TYPES_INC
#define TYPES_INC

#define SD_CARD_MOUNTED  0
#define BUTTON_PRESSED  1

#define TRUE 1
#define FALSE 0
#define HEX_TYPE_DATA 0
#define HEX_TYPE_END_FILE 1
#define HEX_TYPE_LINEAR_SEGMENT 4
#define HEX_FILE_NAME "BootImg.asr"
#define DEBUG_TO_UART  1
#define USER_APP_RESRT_ADDR 0x9D00A000
 typedef struct {
    unsigned short dataLength;
    unsigned short type;
    unsigned long  addrSegment;
    unsigned long  addrOffset;
    unsigned long  realAddess;
    unsigned short hexBinData[16];
    unsigned short checkSum;
 } hexLine_t;
 
 typedef enum {
    eResultOk = 0,
    eResultLastChunk,
    eErrReadHexLine,
    eErrNoDelimiter,
    eErrChecksum,
    eParseFailed,
    eErrResult
 }enResult;

 #endif