#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/AserHofferBL.c"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
#line 15 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
 typedef struct {
 unsigned short dataLength;
 unsigned short type;
 unsigned long addrSegment;
 unsigned long addrOffset;
 unsigned long realAddess;
 unsigned short hexBinData[16];
 unsigned short checkSum;
 } hexLine_t;

 typedef enum {
 eResultOk = 0,
 eResultLastChunk,
 eErrReadHexLine,
 eErrNoDelimiter,
 eErrChecksum,
 eParseFailed,
 eErrResult
 }enResult;
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/sdcard.h"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
#line 4 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/sdcard.h"
enResult getHexAsciiLine(char *ptrHexLineBuffer);
enResult SD_initDriver();
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/flash.h"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
#line 5 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/flash.h"
void writeDataToShadowOfFlashBlock(hexLine_t *ptrHexObj);
void writeShadowToFlash(void);
void initShadowMemory();
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/bootloader.h"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
#line 4 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/bootloader.h"
unsigned short isBootloaderMode();
enResult runBootloader();
#line 68 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/AserHofferBL.c"
sbit TEST_LED_PORT at PORTB.B1;
sbit TEST_LED at LATB1_bit;
sbit TEST_LED_Direction at TRISB1_bit;


sbit Mmc_Chip_Select at LATD12_bit;
sbit Mmc_Chip_Select_Direction at TRISD12_bit;

sbit CARD_DETECT at PORTD.B13;
sbit CARD_DETECT_Direction at TRISD13_bit;

sbit USER_BUTTON_DETECT at PORTB.B0;
sbit USER_BUTTON at PORTD.B0;
sbit USER_BUTTON_Direction at TRISB0_bit;



void configBoard();
void launchUserApplication(unsigned short isAfterBootload);
unsigned short isUseApplocationExist();
unsigned short isApplicationExist(void);




void launchUserApplication(unsigned short isAfterBootload){
unsigned short i;

 if (isAfterBootload ==  1 ){
 for (i=0 ; i<3; i++){
 Delay_ms(500);
 Sound_Play(4000,1000);
 }
 }

 R30 =  0x9D00A000 ;
 asm {
 JR R30
 NOP
 }
}


unsigned short isApplicationExist() {

 unsigned long FirsAppWord;

 memcpy(&FirsAppWord,(char *) 0x9D00A000 ,4);
 if (FirsAppWord == 0xFFFFFFFF){
 return  0 ;
 } else {
 return  1 ;
 }
}


short enableSDcard(){

 SPI3CONbits.ON = 1;
 SPI3_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 80, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);
 SPI_Set_Active(SPI3_Read, SPI3_Write);
 Delay_ms(10);

 return 1;
}




short FAT32_X_Init(){
 short err_intern = 0;

 if(CARD_DETECT ==  1 ){

 return -2;
 }

 enableSDcard();

 err_intern = FAT32_Init();
 return err_intern;
}



enResult SD_initDriver(){
 int err = 0;

 err = FAT32_X_Init();
 if(err < 0){
 TEST_LED = 1;
 }
 else{

 }

 return eResultOk;
}



void configBoard(){
 int i = 0;
 JTAGEN_bit = 0;
 AD1PCFG = 0xFFFF;

 TRISA = 0xFFFF;
 TRISB = 0xFFFF;
 TRISC = 0xFFFF;
 TRISD = 0xFFFF;
 TRISE = 0xFFFF;
 TRISF = 0xFFFF;
 TRISG = 0xFFFF;



 TEST_LED_Direction =  0 ;
 USER_BUTTON_Direction =  1 ;
 CARD_DETECT_Direction =  1 ;



 TEST_LED =  0 ;
 for(i = 0; i < 10; i++){
 TEST_LED = ~TEST_LED_PORT;
 Delay_ms(100);
 }
 TEST_LED =  1 ;

 DisableInterrupts();




 SD_initDriver();
 Sound_Init(&PORTD, 3);
}





void main() {
 enResult eresult;
 unsigned short i;


 configBoard();


 for (i = 0; i < 3; i++){

 TEST_LED = ~TEST_LED_PORT;
 Delay_ms(200);
 }


 i = isBootloaderMode();
 if( i ==  1 ) {
 initShadowMemory();
 eresult = runBootloader();
 if (eresult == eResultOk) {
 DisableInterrupts();
 launchUserApplication( 1 );
 }
 }else {
 if (isApplicationExist() ==  1 ){
 DisableInterrupts();
 launchUserApplication( 0 );
 }
#line 244 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/AserHofferBL.c"
 }
 while ( 1 ) {
 Sound_Play(4000,200);
 TEST_LED = ~TEST_LED_PORT;
 Delay_ms(500);
 }
}
