_getHexAsciiLine:
;bootloader.c,21 :: 		enResult getHexAsciiLine( char *ptrHexLineBuffer){
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;bootloader.c,23 :: 		short err_short = 0;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
;bootloader.c,25 :: 		unsigned char receivedByte = 0;
MOVZ	R30, R0, R0
SB	R30, 21(SP)
;bootloader.c,26 :: 		int cnt_int = 0;
MOVZ	R30, R0, R0
SH	R30, 22(SP)
;bootloader.c,29 :: 		filehandle_intern =  FAT32_Open(HEX_FILE_NAME ,FILE_READ);
SW	R25, 16(SP)
ORI	R26, R0, 1
LUI	R25, hi_addr(?lstr1_bootloader+0)
ORI	R25, R25, lo_addr(?lstr1_bootloader+0)
JAL	_FAT32_Open+0
NOP	
SB	R2, 20(SP)
;bootloader.c,30 :: 		err_short = FAT32_Read(filehandle_intern, &receivedByte, 1);                // read one byte into filebuffer, we expect a ":"
ADDIU	R3, SP, 21
ORI	R27, R0, 1
MOVZ	R26, R3, R0
SEB	R25, R2
JAL	_FAT32_Read+0
NOP	
LW	R25, 16(SP)
;bootloader.c,31 :: 		*ptrHexLineBuffer = receivedByte;
LBU	R2, 21(SP)
SB	R2, 0(R25)
;bootloader.c,32 :: 		ptrHexLineBuffer++;
ADDIU	R2, R25, 1
MOVZ	R25, R2, R0
;bootloader.c,33 :: 		cnt_int++;
LH	R2, 22(SP)
ADDIU	R2, R2, 1
SH	R2, 22(SP)
;bootloader.c,34 :: 		cursorPositionInFile_ulint++;
LW	R2, Offset(getHexAsciiLine_cursorPositionInFile_ulint_L0+0)(GP)
ADDIU	R2, R2, 1
SW	R2, Offset(getHexAsciiLine_cursorPositionInFile_ulint_L0+0)(GP)
;bootloader.c,35 :: 		err_short = FAT32_Seek(filehandle_intern, cursorPositionInFile_ulint);      // increase cursor one step in File
SW	R25, 16(SP)
MOVZ	R26, R2, R0
LB	R25, 20(SP)
JAL	_FAT32_Seek+0
NOP	
LW	R25, 16(SP)
;bootloader.c,36 :: 		do{
L_getHexAsciiLine0:
;bootloader.c,37 :: 		err_short = FAT32_Read(filehandle_intern, &receivedByte, 1);              // read one byte into filebuffer
ADDIU	R2, SP, 21
SW	R25, 16(SP)
ORI	R27, R0, 1
MOVZ	R26, R2, R0
LB	R25, 20(SP)
JAL	_FAT32_Read+0
NOP	
LW	R25, 16(SP)
;bootloader.c,38 :: 		if( receivedByte == 0x3A )                                                // if received char is ":" break and dont save it
LBU	R3, 21(SP)
ORI	R2, R0, 58
BEQ	R3, R2, L__getHexAsciiLine58
NOP	
J	L_getHexAsciiLine3
NOP	
L__getHexAsciiLine58:
;bootloader.c,39 :: 		break;
J	L_getHexAsciiLine1
NOP	
L_getHexAsciiLine3:
;bootloader.c,40 :: 		*ptrHexLineBuffer = receivedByte;
LBU	R2, 21(SP)
SB	R2, 0(R25)
;bootloader.c,41 :: 		ptrHexLineBuffer++;
ADDIU	R2, R25, 1
MOVZ	R25, R2, R0
;bootloader.c,42 :: 		cursorPositionInFile_ulint++;
LW	R2, Offset(getHexAsciiLine_cursorPositionInFile_ulint_L0+0)(GP)
ADDIU	R3, R2, 1
SW	R3, Offset(getHexAsciiLine_cursorPositionInFile_ulint_L0+0)(GP)
;bootloader.c,43 :: 		cnt_int++;
LH	R2, 22(SP)
ADDIU	R2, R2, 1
SH	R2, 22(SP)
;bootloader.c,44 :: 		err_short = FAT32_Seek(filehandle_intern, cursorPositionInFile_ulint);
SW	R25, 16(SP)
MOVZ	R26, R3, R0
LB	R25, 20(SP)
JAL	_FAT32_Seek+0
NOP	
LW	R25, 16(SP)
;bootloader.c,45 :: 		}while( cnt_int < 45 );                                                     // stay in loop until max buffer size
LH	R2, 22(SP)
SLTI	R2, R2, 45
BEQ	R2, R0, L__getHexAsciiLine59
NOP	
J	L_getHexAsciiLine0
NOP	
L__getHexAsciiLine59:
L_getHexAsciiLine1:
;bootloader.c,47 :: 		FAT32_Close(filehandle_intern);
LB	R25, 20(SP)
JAL	_FAT32_Close+0
NOP	
;bootloader.c,48 :: 		return  eResultOk;
MOVZ	R2, R0, R0
;bootloader.c,49 :: 		}
;bootloader.c,48 :: 		return  eResultOk;
;bootloader.c,49 :: 		}
L_end_getHexAsciiLine:
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _getHexAsciiLine
_isBootloaderMode:
;bootloader.c,55 :: 		unsigned short  isBootloaderMode() {
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;bootloader.c,57 :: 		if(USER_BUTTON_DETECT == 1){  // if button is pressed
SW	R25, 4(SP)
_LX	
EXT	R2, R2, BitPos(USER_BUTTON_DETECT+0), 1
BNE	R2, 1, L__isBootloaderMode62
NOP	
J	L_isBootloaderMode4
NOP	
L__isBootloaderMode62:
;bootloader.c,58 :: 		Delay_ms(500);             // wait if button is still pressed
LUI	R24, 203
ORI	R24, R24, 29524
L_isBootloaderMode5:
ADDIU	R24, R24, -1
BNE	R24, R0, L_isBootloaderMode5
NOP	
NOP	
NOP	
;bootloader.c,60 :: 		if( (USER_BUTTON_DETECT == BUTTON_PRESSED) && (CARD_DETECT == SD_CARD_MOUNTED) ){   // if button is still pressed & Sd card inserted
_LX	
EXT	R2, R2, BitPos(USER_BUTTON_DETECT+0), 1
BNE	R2, 1, L__isBootloaderMode64
NOP	
J	L__isBootloaderMode47
NOP	
L__isBootloaderMode64:
_LX	
EXT	R2, R2, BitPos(CARD_DETECT+0), 1
BEQ	R2, R0, L__isBootloaderMode65
NOP	
J	L__isBootloaderMode46
NOP	
L__isBootloaderMode65:
L__isBootloaderMode45:
;bootloader.c,62 :: 		res = FAT32_Exists(HEX_FILE_NAME);
LUI	R25, hi_addr(?lstr2_bootloader+0)
ORI	R25, R25, lo_addr(?lstr2_bootloader+0)
JAL	_FAT32_Exists+0
NOP	
;bootloader.c,63 :: 		return (res == 1)? TRUE : FALSE ;
ANDI	R3, R2, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__isBootloaderMode66
NOP	
J	L_isBootloaderMode10
NOP	
L__isBootloaderMode66:
; ?FLOC___isBootloaderMode?T17 start address is: 8 (R2)
ORI	R2, R0, 1
; ?FLOC___isBootloaderMode?T17 end address is: 8 (R2)
J	L_isBootloaderMode11
NOP	
L_isBootloaderMode10:
; ?FLOC___isBootloaderMode?T17 start address is: 8 (R2)
MOVZ	R2, R0, R0
; ?FLOC___isBootloaderMode?T17 end address is: 8 (R2)
L_isBootloaderMode11:
; ?FLOC___isBootloaderMode?T17 start address is: 8 (R2)
; ?FLOC___isBootloaderMode?T17 end address is: 8 (R2)
J	L_end_isBootloaderMode
NOP	
;bootloader.c,60 :: 		if( (USER_BUTTON_DETECT == BUTTON_PRESSED) && (CARD_DETECT == SD_CARD_MOUNTED) ){   // if button is still pressed & Sd card inserted
L__isBootloaderMode47:
L__isBootloaderMode46:
;bootloader.c,65 :: 		return FALSE;
MOVZ	R2, R0, R0
J	L_end_isBootloaderMode
NOP	
;bootloader.c,68 :: 		}
L_isBootloaderMode4:
;bootloader.c,70 :: 		}
L_end_isBootloaderMode:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _isBootloaderMode
_getByteBinValue:
;bootloader.c,72 :: 		unsigned  short getByteBinValue(char * ptrFirstHexChar){
;bootloader.c,73 :: 		unsigned short1 = 0;
;bootloader.c,74 :: 		unsigned short2 = 0;
;bootloader.c,84 :: 		short1 = lut[ptrFirstHexChar[0]] << 4;
LBU	R2, 0(R25)
ANDI	R3, R2, 255
LUI	R2, hi_addr(getByteBinValue_lut_L0+0)
ORI	R2, R2, lo_addr(getByteBinValue_lut_L0+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R4, R2, 4
;bootloader.c,85 :: 		short2 = lut[ptrFirstHexChar[1]];
ADDIU	R2, R25, 1
LBU	R2, 0(R2)
ANDI	R3, R2, 255
LUI	R2, hi_addr(getByteBinValue_lut_L0+0)
ORI	R2, R2, lo_addr(getByteBinValue_lut_L0+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
; short2 start address is: 12 (R3)
ANDI	R3, R2, 255
;bootloader.c,86 :: 		return short1 | short2;
OR	R2, R4, R3
; short2 end address is: 12 (R3)
;bootloader.c,88 :: 		}
L_end_getByteBinValue:
JR	RA
NOP	
; end of _getByteBinValue
_pharseHexLine:
;bootloader.c,90 :: 		enResult pharseHexLine(hexLine_t *ptrHexLineObj,char *ptrRawHexLine ){
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;bootloader.c,91 :: 		unsigned short checkSum = 0;
;bootloader.c,93 :: 		if( ptrRawHexLine[0] != ':'){
LBU	R2, 0(R26)
ANDI	R3, R2, 255
ORI	R2, R0, 58
BNE	R3, R2, L__pharseHexLine70
NOP	
J	L_pharseHexLine13
NOP	
L__pharseHexLine70:
;bootloader.c,94 :: 		return eErrNoDelimiter;
ORI	R2, R0, 3
J	L_end_pharseHexLine
NOP	
;bootloader.c,95 :: 		}
L_pharseHexLine13:
;bootloader.c,97 :: 		ptrHexLineObj->dataLength = getByteBinValue(&ptrRawHexLine[1]);
MOVZ	R2, R25, R0
SW	R2, 8(SP)
ADDIU	R2, R26, 1
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_getByteBinValue+0
NOP	
LW	R25, 4(SP)
LW	R3, 8(SP)
SB	R2, 0(R3)
;bootloader.c,98 :: 		ptrHexLineObj->addrOffset = ((unsigned long)getByteBinValue(&ptrRawHexLine[3])) <<8 ;
ADDIU	R2, R25, 8
SW	R2, 8(SP)
ADDIU	R2, R26, 3
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_getByteBinValue+0
NOP	
LW	R25, 4(SP)
ANDI	R2, R2, 255
SLL	R3, R2, 8
LW	R2, 8(SP)
SW	R3, 0(R2)
;bootloader.c,99 :: 		ptrHexLineObj->addrOffset += ((unsigned long)getByteBinValue(&ptrRawHexLine[5]));
ADDIU	R2, R25, 8
SW	R2, 8(SP)
ADDIU	R2, R26, 5
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_getByteBinValue+0
NOP	
LW	R25, 4(SP)
ANDI	R4, R2, 255
LW	R3, 8(SP)
LW	R2, 0(R3)
ADDU	R2, R2, R4
SW	R2, 0(R3)
;bootloader.c,100 :: 		ptrHexLineObj->type       =  getByteBinValue(&ptrRawHexLine[7]);
ADDIU	R2, R25, 1
SW	R2, 8(SP)
ADDIU	R2, R26, 7
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_getByteBinValue+0
NOP	
LW	R25, 4(SP)
LW	R3, 8(SP)
SB	R2, 0(R3)
;bootloader.c,101 :: 		ptrHexLineObj->checkSum   =  getByteBinValue(&ptrRawHexLine[9+2*ptrHexLineObj->dataLength]);
ADDIU	R2, R25, 32
SW	R2, 8(SP)
LBU	R2, 0(R25)
ANDI	R2, R2, 255
SLL	R2, R2, 1
ADDIU	R2, R2, 9
SEH	R2, R2
ADDU	R2, R26, R2
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_getByteBinValue+0
NOP	
LW	R25, 4(SP)
LW	R3, 8(SP)
SB	R2, 0(R3)
;bootloader.c,102 :: 		if( ptrHexLineObj->type == HEX_TYPE_DATA){
ADDIU	R2, R25, 1
LBU	R2, 0(R2)
ANDI	R2, R2, 255
BEQ	R2, R0, L__pharseHexLine71
NOP	
J	L_pharseHexLine14
NOP	
L__pharseHexLine71:
;bootloader.c,103 :: 		for (i = 0; i < ptrHexLineObj->dataLength; i++){
; i start address is: 20 (R5)
MOVZ	R5, R0, R0
; i end address is: 20 (R5)
L_pharseHexLine15:
; i start address is: 20 (R5)
LBU	R2, 0(R25)
ANDI	R3, R5, 255
ANDI	R2, R2, 255
SLTU	R2, R3, R2
BNE	R2, R0, L__pharseHexLine72
NOP	
J	L_pharseHexLine16
NOP	
L__pharseHexLine72:
;bootloader.c,104 :: 		ptrHexLineObj->hexBinData[i] = getByteBinValue(&ptrRawHexLine[9+i+i]); // addiing is faster then 2*i
ADDIU	R3, R25, 16
ANDI	R2, R5, 255
ADDU	R2, R3, R2
SW	R2, 8(SP)
ANDI	R2, R5, 255
ADDIU	R3, R2, 9
ANDI	R2, R5, 255
ADDU	R2, R3, R2
SEH	R2, R2
ADDU	R2, R26, R2
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_getByteBinValue+0
NOP	
LW	R25, 4(SP)
LW	R3, 8(SP)
SB	R2, 0(R3)
;bootloader.c,103 :: 		for (i = 0; i < ptrHexLineObj->dataLength; i++){
ADDIU	R2, R5, 1
ANDI	R5, R2, 255
;bootloader.c,105 :: 		}
; i end address is: 20 (R5)
J	L_pharseHexLine15
NOP	
L_pharseHexLine16:
;bootloader.c,106 :: 		} else if (ptrHexLineObj->type == HEX_TYPE_LINEAR_SEGMENT){
J	L_pharseHexLine18
NOP	
L_pharseHexLine14:
ADDIU	R2, R25, 1
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 4
BEQ	R3, R2, L__pharseHexLine73
NOP	
J	L_pharseHexLine19
NOP	
L__pharseHexLine73:
;bootloader.c,107 :: 		ptrHexLineObj->addrSegment = 0L; // just to be on safe side
ADDIU	R2, R25, 4
SW	R0, 0(R2)
;bootloader.c,109 :: 		ptrHexLineObj->addrSegment = (unsigned long)getByteBinValue( &ptrRawHexLine[9]) << 8;
ADDIU	R2, R25, 4
SW	R2, 8(SP)
ADDIU	R2, R26, 9
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_getByteBinValue+0
NOP	
LW	R25, 4(SP)
ANDI	R2, R2, 255
SLL	R3, R2, 8
LW	R2, 8(SP)
SW	R3, 0(R2)
;bootloader.c,110 :: 		ptrHexLineObj->addrSegment += (unsigned long)getByteBinValue( &ptrRawHexLine[11]);
ADDIU	R2, R25, 4
SW	R2, 8(SP)
ADDIU	R2, R26, 11
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_getByteBinValue+0
NOP	
LW	R25, 4(SP)
ANDI	R4, R2, 255
LW	R3, 8(SP)
LW	R2, 0(R3)
ADDU	R2, R2, R4
SW	R2, 0(R3)
;bootloader.c,111 :: 		ptrHexLineObj->addrSegment = ptrHexLineObj->addrSegment << 16;
ADDIU	R3, R25, 4
LW	R2, 0(R3)
SLL	R2, R2, 16
SW	R2, 0(R3)
;bootloader.c,112 :: 		} else{
J	L_pharseHexLine20
NOP	
L_pharseHexLine19:
;bootloader.c,114 :: 		}
L_pharseHexLine20:
L_pharseHexLine18:
;bootloader.c,116 :: 		if( (ptrRawHexLine[9+2*ptrHexLineObj->dataLength+2] != 0xD) || (ptrRawHexLine[9+2*ptrHexLineObj->dataLength+3 ] != 0xA)){
LBU	R2, 0(R25)
ANDI	R2, R2, 255
SLL	R2, R2, 1
ADDIU	R2, R2, 9
ADDIU	R2, R2, 2
SEH	R2, R2
ADDU	R2, R26, R2
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 13
BEQ	R3, R2, L__pharseHexLine74
NOP	
J	L__pharseHexLine50
NOP	
L__pharseHexLine74:
LBU	R2, 0(R25)
ANDI	R2, R2, 255
SLL	R2, R2, 1
ADDIU	R2, R2, 9
ADDIU	R2, R2, 3
SEH	R2, R2
ADDU	R2, R26, R2
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 10
BEQ	R3, R2, L__pharseHexLine75
NOP	
J	L__pharseHexLine49
NOP	
L__pharseHexLine75:
J	L_pharseHexLine23
NOP	
L__pharseHexLine50:
L__pharseHexLine49:
;bootloader.c,117 :: 		return eParseFailed;
ORI	R2, R0, 5
J	L_end_pharseHexLine
NOP	
;bootloader.c,118 :: 		} else {
L_pharseHexLine23:
;bootloader.c,119 :: 		return eResultOk;
MOVZ	R2, R0, R0
;bootloader.c,123 :: 		}
L_end_pharseHexLine:
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _pharseHexLine
_runBootloader:
;bootloader.c,125 :: 		enResult runBootloader(){
ADDIU	SP, SP, -100
SW	RA, 0(SP)
;bootloader.c,131 :: 		int i = 0;
SW	R25, 4(SP)
SW	R26, 8(SP)
MOVZ	R30, R0, R0
SH	R30, 98(SP)
;bootloader.c,133 :: 		filehandle =  FAT32_Open(HEX_FILE_NAME ,FILE_READ);
ORI	R26, R0, 1
LUI	R25, hi_addr(?lstr3_bootloader+0)
ORI	R25, R25, lo_addr(?lstr3_bootloader+0)
JAL	_FAT32_Open+0
NOP	
SB	R2, 96(SP)
;bootloader.c,134 :: 		if (filehandle < 0){
SEB	R2, R2
SLTI	R2, R2, 0
BNE	R2, R0, L__runBootloader77
NOP	
J	L_runBootloader25
NOP	
L__runBootloader77:
;bootloader.c,135 :: 		return eErrResult;
ORI	R2, R0, 6
J	L_end_runBootloader
NOP	
;bootloader.c,136 :: 		}
L_runBootloader25:
;bootloader.c,138 :: 		do{
L_runBootloader26:
;bootloader.c,139 :: 		eResult = getHexAsciiLine(hexRawLine);
ADDIU	R2, SP, 13
MOVZ	R25, R2, R0
JAL	_getHexAsciiLine+0
NOP	
;bootloader.c,140 :: 		if(eResult == eResultOk){
ANDI	R2, R2, 255
BEQ	R2, R0, L__runBootloader78
NOP	
J	L_runBootloader29
NOP	
L__runBootloader78:
;bootloader.c,141 :: 		eResult = pharseHexLine(& parsedHexLine,hexRawLine );
ADDIU	R3, SP, 13
ADDIU	R2, SP, 60
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_pharseHexLine+0
NOP	
SB	R2, 12(SP)
;bootloader.c,142 :: 		if(eResult != eResultOk){
ANDI	R2, R2, 255
BNE	R2, R0, L__runBootloader80
NOP	
J	L_runBootloader30
NOP	
L__runBootloader80:
;bootloader.c,143 :: 		return eParseFailed;
ORI	R2, R0, 5
J	L_end_runBootloader
NOP	
;bootloader.c,144 :: 		}
L_runBootloader30:
;bootloader.c,146 :: 		if (i++ % 300 == 0){
LH	R3, 98(SP)
LH	R2, 98(SP)
ADDIU	R2, R2, 1
SH	R2, 98(SP)
ORI	R2, R0, 300
DIV	R3, R2
MFHI	R2
SEH	R2, R2
BEQ	R2, R0, L__runBootloader81
NOP	
J	L_runBootloader31
NOP	
L__runBootloader81:
;bootloader.c,147 :: 		Sound_Play(4000,20); // some indication for the user
ORI	R26, R0, 20
ORI	R25, R0, 4000
JAL	_Sound_Play+0
NOP	
;bootloader.c,148 :: 		}
L_runBootloader31:
;bootloader.c,150 :: 		switch (parsedHexLine.type){
J	L_runBootloader32
NOP	
;bootloader.c,151 :: 		case HEX_TYPE_DATA:
L_runBootloader34:
;bootloader.c,152 :: 		parsedHexLine.realAddess = currentAddrSegment + parsedHexLine.addrOffset;
LW	R3, 68(SP)
LW	R2, Offset(runBootloader_currentAddrSegment_L0+0)(GP)
ADDU	R3, R2, R3
SW	R3, 72(SP)
;bootloader.c,153 :: 		if ( (parsedHexLine.realAddess == 0x1FC00380) || (parsedHexLine.realAddess == 0x1FC02FF0) ){ // skip BootVT programming
LUI	R2, 8128
ORI	R2, R2, 896
BNE	R3, R2, L__runBootloader83
NOP	
J	L__runBootloader54
NOP	
L__runBootloader83:
LW	R3, 72(SP)
LUI	R2, 8128
ORI	R2, R2, 12272
BNE	R3, R2, L__runBootloader85
NOP	
J	L__runBootloader53
NOP	
L__runBootloader85:
J	L_runBootloader37
NOP	
L__runBootloader54:
L__runBootloader53:
;bootloader.c,161 :: 		}else{
J	L_runBootloader38
NOP	
L_runBootloader37:
;bootloader.c,162 :: 		writeDataToShadowOfFlashBlock(& parsedHexLine);
ADDIU	R2, SP, 60
MOVZ	R25, R2, R0
JAL	_writeDataToShadowOfFlashBlock+0
NOP	
;bootloader.c,163 :: 		}
L_runBootloader38:
;bootloader.c,164 :: 		break;
J	L_runBootloader33
NOP	
;bootloader.c,165 :: 		case HEX_TYPE_LINEAR_SEGMENT:
L_runBootloader39:
;bootloader.c,166 :: 		currentAddrSegment = parsedHexLine.addrSegment;
LW	R2, 64(SP)
SW	R2, Offset(runBootloader_currentAddrSegment_L0+0)(GP)
;bootloader.c,167 :: 		break;
J	L_runBootloader33
NOP	
;bootloader.c,168 :: 		case HEX_TYPE_END_FILE:
L_runBootloader40:
;bootloader.c,169 :: 		writeShadowToFlash(); // flush the last shadow block to flash memory
JAL	_writeShadowToFlash+0
NOP	
;bootloader.c,170 :: 		FAT32_Close(filehandle);
LB	R25, 96(SP)
JAL	_FAT32_Close+0
NOP	
;bootloader.c,171 :: 		return eResultOk; // finished loading user program
MOVZ	R2, R0, R0
J	L_end_runBootloader
NOP	
;bootloader.c,173 :: 		default:
L_runBootloader41:
;bootloader.c,174 :: 		break;
J	L_runBootloader33
NOP	
;bootloader.c,175 :: 		}
L_runBootloader32:
LBU	R2, 61(SP)
BNE	R2, R0, L__runBootloader87
NOP	
J	L_runBootloader34
NOP	
L__runBootloader87:
LBU	R3, 61(SP)
ORI	R2, R0, 4
BNE	R3, R2, L__runBootloader89
NOP	
J	L_runBootloader39
NOP	
L__runBootloader89:
LBU	R3, 61(SP)
ORI	R2, R0, 1
BNE	R3, R2, L__runBootloader91
NOP	
J	L_runBootloader40
NOP	
L__runBootloader91:
J	L_runBootloader41
NOP	
L_runBootloader33:
;bootloader.c,176 :: 		} else {
J	L_runBootloader42
NOP	
L_runBootloader29:
;bootloader.c,177 :: 		return eErrReadHexLine;
ORI	R2, R0, 2
J	L_end_runBootloader
NOP	
;bootloader.c,178 :: 		}
L_runBootloader42:
;bootloader.c,179 :: 		} while ((eResult == eResultOk) && (parsedHexLine.type !=  HEX_TYPE_END_FILE));
LBU	R2, 12(SP)
BEQ	R2, R0, L__runBootloader92
NOP	
J	L__runBootloader56
NOP	
L__runBootloader92:
LBU	R3, 61(SP)
ORI	R2, R0, 1
BNE	R3, R2, L__runBootloader94
NOP	
J	L__runBootloader55
NOP	
L__runBootloader94:
J	L_runBootloader26
NOP	
L__runBootloader56:
L__runBootloader55:
;bootloader.c,180 :: 		}
L_end_runBootloader:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 100
JR	RA
NOP	
; end of _runBootloader
