#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/bootloader.c"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
#line 15 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
 typedef struct {
 unsigned short dataLength;
 unsigned short type;
 unsigned long addrSegment;
 unsigned long addrOffset;
 unsigned long realAddess;
 unsigned short hexBinData[16];
 unsigned short checkSum;
 } hexLine_t;

 typedef enum {
 eResultOk = 0,
 eResultLastChunk,
 eErrReadHexLine,
 eErrNoDelimiter,
 eErrChecksum,
 eParseFailed,
 eErrResult
 }enResult;
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/sdcard.h"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
#line 4 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/sdcard.h"
enResult getHexAsciiLine(char *ptrHexLineBuffer);
enResult SD_initDriver();
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/flash.h"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/types.h"
#line 5 "c:/users/alexander wolf/documents/projekte/programmierung/pic/programme/eigene programme pic32/bootloader 2/bootloader v002/flash.h"
void writeDataToShadowOfFlashBlock(hexLine_t *ptrHexObj);
void writeShadowToFlash(void);
void initShadowMemory();
#line 10 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/bootloader.c"
extern sfr sbit TEST_LED;
extern sfr sbit TEST_LED_PORT;
extern sfr sbit USER_BUTTON_DETECT;
extern sfr sbit CARD_DETECT;



enResult pharseHexLine(hexLine_t *ptrHexLineObj,char *ptrRawHexLine );



enResult getHexAsciiLine( char *ptrHexLineBuffer){
 static long unsigned int cursorPositionInFile_ulint = 0;
 short err_short = 0;
 short filehandle_intern;
 unsigned char receivedByte = 0;
 int cnt_int = 0;


 filehandle_intern = FAT32_Open( "BootImg.asr"  , 0x1 );
 err_short = FAT32_Read(filehandle_intern, &receivedByte, 1);
 *ptrHexLineBuffer = receivedByte;
 ptrHexLineBuffer++;
 cnt_int++;
 cursorPositionInFile_ulint++;
 err_short = FAT32_Seek(filehandle_intern, cursorPositionInFile_ulint);
 do{
 err_short = FAT32_Read(filehandle_intern, &receivedByte, 1);
 if( receivedByte == 0x3A )
 break;
 *ptrHexLineBuffer = receivedByte;
 ptrHexLineBuffer++;
 cursorPositionInFile_ulint++;
 cnt_int++;
 err_short = FAT32_Seek(filehandle_intern, cursorPositionInFile_ulint);
 }while( cnt_int < 45 );

 FAT32_Close(filehandle_intern);
 return eResultOk;
}





unsigned short isBootloaderMode() {
 unsigned short res;
 if(USER_BUTTON_DETECT == 1){
 Delay_ms(500);

 if( (USER_BUTTON_DETECT ==  1 ) && (CARD_DETECT ==  0 ) ){

 res = FAT32_Exists( "BootImg.asr" );
 return (res == 1)?  1  :  0  ;
 } else {
 return  0 ;
 }

 }

}

unsigned short getByteBinValue(char * ptrFirstHexChar){
 unsigned short1 = 0;
 unsigned short2 = 0;
 static unsigned short lut[] = { 0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0,0,1,
 2,3,4,5,6,7,8,9,0,0,
 0,0,0,0,0,10,11,12,13,14,
 15
 };
 short1 = lut[ptrFirstHexChar[0]] << 4;
 short2 = lut[ptrFirstHexChar[1]];
 return short1 | short2;

}

enResult pharseHexLine(hexLine_t *ptrHexLineObj,char *ptrRawHexLine ){
unsigned short checkSum = 0;
unsigned short i;
 if( ptrRawHexLine[0] != ':'){
 return eErrNoDelimiter;
 }

 ptrHexLineObj->dataLength = getByteBinValue(&ptrRawHexLine[1]);
 ptrHexLineObj->addrOffset = ((unsigned long)getByteBinValue(&ptrRawHexLine[3])) <<8 ;
 ptrHexLineObj->addrOffset += ((unsigned long)getByteBinValue(&ptrRawHexLine[5]));
 ptrHexLineObj->type = getByteBinValue(&ptrRawHexLine[7]);
 ptrHexLineObj->checkSum = getByteBinValue(&ptrRawHexLine[9+2*ptrHexLineObj->dataLength]);
 if( ptrHexLineObj->type ==  0 ){
 for (i = 0; i < ptrHexLineObj->dataLength; i++){
 ptrHexLineObj->hexBinData[i] = getByteBinValue(&ptrRawHexLine[9+i+i]);
 }
 } else if (ptrHexLineObj->type ==  4 ){
 ptrHexLineObj->addrSegment = 0L;

 ptrHexLineObj->addrSegment = (unsigned long)getByteBinValue( &ptrRawHexLine[9]) << 8;
 ptrHexLineObj->addrSegment += (unsigned long)getByteBinValue( &ptrRawHexLine[11]);
 ptrHexLineObj->addrSegment = ptrHexLineObj->addrSegment << 16;
 } else{

 }

 if( (ptrRawHexLine[9+2*ptrHexLineObj->dataLength+2] != 0xD) || (ptrRawHexLine[9+2*ptrHexLineObj->dataLength+3 ] != 0xA)){
 return eParseFailed;
 } else {
 return eResultOk;
 }


}

enResult runBootloader(){
 enResult eResult;
 static unsigned long currentAddrSegment = 0;
 char hexRawLine[1+2+4+2+32+2+2];
 hexLine_t parsedHexLine;
 short filehandle;
 int i = 0;

 filehandle = FAT32_Open( "BootImg.asr"  , 0x1 );
 if (filehandle < 0){
 return eErrResult;
 }

 do{
 eResult = getHexAsciiLine(hexRawLine);
 if(eResult == eResultOk){
 eResult = pharseHexLine(& parsedHexLine,hexRawLine );
 if(eResult != eResultOk){
 return eParseFailed;
 }

 if (i++ % 300 == 0){
 Sound_Play(4000,20);
 }

 switch (parsedHexLine.type){
 case  0 :
 parsedHexLine.realAddess = currentAddrSegment + parsedHexLine.addrOffset;
 if ( (parsedHexLine.realAddess == 0x1FC00380) || (parsedHexLine.realAddess == 0x1FC02FF0) ){
#line 161 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme PIC32/Bootloader 2/Bootloader v002/bootloader.c"
 }else{
 writeDataToShadowOfFlashBlock(& parsedHexLine);
 }
 break;
 case  4 :
 currentAddrSegment = parsedHexLine.addrSegment;
 break;
 case  1 :
 writeShadowToFlash();
 FAT32_Close(filehandle);
 return eResultOk;
 break;
 default:
 break;
 }
 } else {
 return eErrReadHexLine;
 }
 } while ((eResult == eResultOk) && (parsedHexLine.type !=  1 ));
}
